var url = 'http://eventmobi.com/teach15/?cordova=true';

function isConnected() {
  return window.navigator.onLine;
  //return window.navigator.connection !== Connection.NONE;
}

function getCordovaDeviceType() {
  var ua = window.navigator.userAgent;

  if (ua.indexOf('iPhone') !== -1 || ua.indexOf('iPad') !== -1) {
    return 'ios';
  } else if (ua.indexOf('Android') !== -1) {
    return 'android';
  } else if (ua.indexOf('BB10') !== -1) {
    return 'blackberry10';
  } else if (ua.indexOf('Windows') !== -1) {
    return 'wp8';
  }

  return null;
}

function writeToFileSystem(writeObj, done) {
  // No file system write support for Windows Phone
  if (getCordovaDeviceType() !== 'wp8') {
    var fail = function(error) {
      console.log('FS error: ', error);
    };

    var requestFS = function() {
      window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, gotFSWrite, fail);
    };

    var gotFSWrite = function(fileSystem) {
      fileSystem.root.getDirectory(writeObj.directory, {
        create: true,
        exclusive: false
      }, gotDir, fail);
    };

    var gotDir = function(dirEntry) {
      dirEntry.getFile(writeObj.file, {
        create: true,
        exclusive: false
      }, gotFileEntryWrite, fail);
    };

    var gotFileEntryWrite = function(fileEntry) {
      fileEntry.createWriter(gotFileWriter, fail);
    };

    var gotFileWriter = function(writer) {
      writer.write(writeObj.data);
      done();
    };

    /* Start the cascade to write to ONE FILE! */
    requestFS();
  } else {
    done();
  }
}

function onBodyLoad() {
  document.addEventListener("deviceready", onDeviceReady, false);

  if (getCordovaDeviceType() === 'wp8') { // No offline support for Windows phone
    document.getElementById('offline').style.display = 'none';
    document.getElementById('no-offline').style.display = 'inline';
  }
}

function onDeviceReady() {
  if (isConnected()) {
    writeToFileSystem({
      directory: '.',
      file: '5TouchSolutions-nativeSections',
      data: JSON.stringify(window.emNativeSections || {})
    }, function() {
      window.location.replace(url);
    });
  } else if (getCordovaDeviceType() === 'wp8') { // No offline support for Windows phone
    fail();
  } else {
    requestFS();
  }
}

function reconnecting() {
  setInterval(function() {
    if (isConnected()) {
      window.location.replace(url);
    }
  }, 5000);
}

function fail(error) {
  navigator.splashscreen.hide();
  document.getElementById('error').style.display = 'block';
  reconnecting();
}

function requestFS() {
  window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, gotFSRead, fail);
}

// Read from FileSystem
function gotFSRead(fileSystem) {
  fileSystem.root.getDirectory('.', {
    create: true,
    exclusive: false
  }, gotDir, fail);
}

function gotDir(dirEntry) {
  dirEntry.getFile('5TouchSolutions-teach15-dataLoaded.txt', {
    create: true,
    exclusive: false
  }, gotFileEntryRead, fail);
}

function gotFileEntryRead(fileEntry) {
  fileEntry.file(gotFileReader, fail);
}

function gotFileReader(file) {
  readAsText(file);
}

function readAsText(file) {
  var reader = new FileReader();
  reader.onloadend = function(evt) {
    // Read success
    var result = evt.target.result;
    if (result === 'true') {
      window.location.replace(url);
    } else {
      fail(null);
    }
  };
  reader.readAsText(file);
}